/*
 *
 * This is part of the ANL/MCS/FL CAVEav distribution.
 * written by Ivan R. Judson
 *
 */

#include <fileCAVcam.h>

fileCAVcam::fileCAVcam(char *fn, int width, int height, int depth,
			 float ex, float ey, float ez, 
			 float cx, float cy, float cz, 
			 float ux, float uy, float uz) : CAVcam(ex, ey, ez,
								 cx, cy, cz,
								 ux, uy, uz)
{
  fnbase = fn;
  _fb_width = width; _fb_height = height; _fb_depth = depth;
  _fb_size = _fb_width * _fb_height;
  _imagepool = new FLImagePool(_fb_width, _fb_height, _fb_depth, 10);
  _format = GL_RGB;
}

fileCAVcam::~fileCAVcam()
{
  delete _imagepool;
}

void fileCAVcam::Init(void)
{
#if defined(GLXPIXMAP) || defined(PBUFFER)
  CAVcam::setupOffscreen();
#endif
}

void fileCAVcam::PutPix()
{
  FILE *fp;
  char fn[128];
  FLImageDescriptor *image;
  int w, h, d;

  sprintf(fn, "%s%d.raw", fnbase, _fc++);

#ifdef DEBUG
  fprintf(stderr, "Opening %s to write to...", fn);
#endif

  image = &(_imagepool->_tmpim);
  w = image->GetWidth();
  h = image->GetHeight();
  d = image->GetDepth();

  if((fp = fopen(fn, "w")) != NULL) 
    {
      if(fwrite((void *)image->GetData(), w * h * d, 1, fp)) 
	{
	  fclose(fp);
#ifdef DEBUG
	  fprintf(stderr, "closed.\n");
#endif
	} else {
	  perror("Can't write frame");
	}
    } else {
      perror("Can't open file");
    }
}

