#ifndef _JpegEncoder_h
#define _JpegEncoder_h

#include <dmedia/dm_imageconvert.h>
#include <dmedia/dm_jpeg.h>

class JpegEncoder
{
public:
    JpegEncoder(int width, int height, DMimagepacking packing, int q);
    ~JpegEncoder();

    void convertFrame(void *frame, DMbuffer *buffer);
    void setQuality(int q);
    
private:
    void fatal(char *msg);
    
    void createConverter();
    int findJpegConverter(DMcodedirection direction);
    void configConverterSource(int width, int height, DMimagepacking packing);
    void configConverterDest();
    void configConverter();
    void configSourcePool();
    void configDestPool();
    
    DMimageconverter ic_;

    DMbufferpool srcPool_, dstPool_;

    int q_;

    int srcPoolFd_;
    int convFd_;

    int imageSize_;
    int sourcePoolSize_;
    int destPoolSize_;
};

#endif
