#ifndef _Params_h
#define _Params_h

#include <dmedia/dm_params.h>

class Params
{
public:
    Params();
//    Params(const DMparams *);

    ~Params();

    void reset();

    DMparams *getDMparams() { return params_; }

    int getEnum(const char *name) {
	return dmParamsGetEnum(params_, name);
    }
    
    int getInt(const char *name) {
	return dmParamsGetInt(params_, name);
    }
    
    long long getLongLong(const char *name) {
	return dmParamsGetLongLong(params_, name);
    }
    
    const char * getString(const char *name) {
	return dmParamsGetString(params_, name);
    }
    

    const void * getBinary(const char *name, size_t *dataSize) {
	return dmParamsGetBinary(params_, name, dataSize);
    }

    float getFloat(const char *name) {
	return dmParamsGetFloat(params_, name);
    }
    
/*
    Params * getParams(const char *name) {
	return new Params(dmParamsGetParams(params_, name));
    }
*/
    
    const DMenumarray * getEnumArray(const char *name) {
	return dmParamsGetEnumArray(params_, name);
    }
    
    const DMintarray * getIntArray(const char *name) {
	return dmParamsGetIntArray(params_, name);
    }
    
    const DMstringarray * getStringArray(const char *name) {
	return dmParamsGetStringArray(params_, name);
    }
    
    const DMfractionarray * getFractArray(const char *name) {
	return dmParamsGetFractArray(params_, name);
    }
    
    const DMfloatarray * getFloatArray(const char *name) {
	return dmParamsGetFloatArray(params_, name);
    }
    
    const DMintrange * getIntRange(const char *name) {
	return dmParamsGetIntRange(params_, name);
    }
    
    const DMfloatrange * getFloatRange(const char *name) {
	return dmParamsGetFloatRange(params_, name);
    }
    
    const DMfractionrange * getFractRange(const char *name) {
	return dmParamsGetFractRange(params_, name);
    }

    DMstatus setEnum(const char* paramName, const int value) {
        return dmParamsSetEnum(params_, paramName, value);
    }
    DMstatus setLongLong(const char* paramName, const long long value) {
        return dmParamsSetLongLong(params_, paramName, value);
    }
    DMstatus setInt(const char* paramName, const int value) {
        return dmParamsSetInt(params_, paramName, value);
    }
    DMstatus setString(const char* paramName, const char* value) {
        return dmParamsSetString(params_, paramName, value);
    }
    DMstatus setBinary(const char* paramName, const size_t dataSize, const void* data) {
        return dmParamsSetBinary(params_, paramName, dataSize, data);
    }
    DMstatus setFloat(const char* paramName, const double value) {
        return dmParamsSetFloat(params_, paramName, value);
    }
    DMstatus setFract(const char* paramName, const DMfraction value) {
        return dmParamsSetFract(params_, paramName, value);
    }
    DMstatus setParams(const char* paramName, const DMparams* value) {
        return dmParamsSetParams(params_, paramName, value);
    }
    DMstatus setEnumArray(const char* paramName, const DMenumarray* value) {
        return dmParamsSetEnumArray(params_, paramName, value);
    }
    DMstatus setIntArray(const char* paramName, const DMintarray* value) {
        return dmParamsSetIntArray(params_, paramName, value);
    }
    DMstatus setStringArray(const char* paramName, const DMstringarray* value) {
        return dmParamsSetStringArray(params_, paramName, value);
    }
    DMstatus setFloatArray(const char* paramName, const DMfloatarray* value) {
        return dmParamsSetFloatArray(params_, paramName, value);
    }
    DMstatus setFractArray(const char* paramName, const DMfractionarray* value) {
        return dmParamsSetFractArray(params_, paramName, value);
    }
    DMstatus setIntRange(const char* paramName, const DMintrange* value) {
        return dmParamsSetIntRange(params_, paramName, value);
    }
    DMstatus setFloatRange(const char* paramName, const DMfloatrange* value) {
        return dmParamsSetFloatRange(params_, paramName, value);
    }
    DMstatus setFractRange(const char* paramName, const DMfractionrange* value) {
        return dmParamsSetFractRange(params_, paramName, value);
    }

private:
    DMparams *params_;
    
};

#endif
